// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "TurkmenNP.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_FORMAT, OnViewFormat)
	ON_UPDATE_COMMAND_UI(ID_VIEW_FORMAT, OnUpdateViewFormat)
	ON_COMMAND(ID_ENGLISHLANG, OnEnglishlang)
	ON_UPDATE_COMMAND_UI(ID_ENGLISHLANG, OnUpdateEnglishlang)
	ON_COMMAND(ID_TURKMENLANG, OnTurkmenlang)
	ON_UPDATE_COMMAND_UI(ID_TURKMENLANG, OnUpdateTurkmenlang)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	nActiveLanguage = AL_TURKMEN;
}

CMainFrame::~CMainFrame()
{
	CMenu::FromHandle(hTurkmenMenu)->DestroyMenu();
	delete pTurkmenMenu;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}


	if (!m_wndFormatToolbar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC,CRect(0,0,0,0),IDR_FORMAT_TOOLBAR) ||
		!m_wndFormatToolbar.LoadToolBar(IDR_FORMAT_TOOLBAR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}



	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	//add a dropdown list
	/*m_wndFormatToolbar.GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);

	TBBUTTON new_button;
	new_button.fsStyle = TBSTYLE_DROPDOWN ;
	new_button.fsState = TBSTATE_ENABLED;
	new_button.idCommand = ID_VIEW_FONT;
	m_wndFormatToolbar.GetToolBarCtrl().AddButtons(1, &new_button);*/

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY );
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_wndFormatToolbar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndFormatToolbar);

	//////// turkmen menu creation //////////
	Small_S_cedilla.Format(_T("%c"),SMALL_S_CEDILLA);
	Small_N_caron.Format(_T("%c"),SMALL_N_CARON);
	Capital_S_cedilla.Format(_T("%c"),CAPITAL_S_CEDILLA);
	Capital_N_caron.Format(_T("%c"),CAPITAL_N_CARON);
	
	pTurkmenMenu = new CMenu();
	pTurkmenMenu->LoadMenu(IDR_MAINFRAMETURKMEN);
	ModifyMenu(pTurkmenMenu);

	hTurkmenMenu = pTurkmenMenu->GetSafeHmenu();
	hEnglishMenu = GetMenu()->GetSafeHmenu();
	SetMenu(pTurkmenMenu);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnViewFormat() 
{
	ShowControlBar(&m_wndFormatToolbar,!m_wndFormatToolbar.IsWindowVisible(),FALSE);	
	RecalcLayout();
}


void CMainFrame::OnUpdateViewFormat(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_wndFormatToolbar.IsWindowVisible());	
}


BOOL CMainFrame::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	if (((LPNMHDR)lParam)->code == TBN_DROPDOWN)
	{
	}	
	return CFrameWnd::OnNotify(wParam, lParam, pResult);
}


////////////////////////////////////////////////////////////////////////////////////
void CMainFrame::ModifyMenu(CMenu* pMenu)
{
	UINT nPosition; 
	UINT nCount;
	CString string;

	nCount = pMenu->GetMenuItemCount();
	
	for (nPosition = 0; nPosition < nCount; nPosition++)
	{
			
		pMenu->GetMenuString(nPosition,string,MF_BYPOSITION);
		if(string.IsEmpty())
			continue;
		
		string.Replace(SMALL_X, Small_S_cedilla[0]);
		string.Replace(CAPITAL_X, Capital_S_cedilla[0]);
		string.Replace(SMALL_Q, Capital_N_caron[0]);
 
		pMenu->ModifyMenu(nPosition,MF_BYPOSITION|MF_STRING,
			pMenu->GetMenuItemID(nPosition),string);
	
		//recursive call
		if(pMenu->GetSubMenu(nPosition))
			ModifyMenu(pMenu->GetSubMenu(nPosition));
	}
}
////////////////////////////////////////////////////////////////////////////////////

void CMainFrame::OnEnglishlang() 
{
	if (nActiveLanguage == AL_ENGLISH)
		return;
	SetMenu(CMenu::FromHandle(hEnglishMenu));
	nActiveLanguage = AL_ENGLISH;	
}

void CMainFrame::OnUpdateEnglishlang(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(nActiveLanguage == AL_ENGLISH);
}

void CMainFrame::OnTurkmenlang() 
{
	if (nActiveLanguage == AL_TURKMEN)
		return;
	SetMenu(CMenu::FromHandle(hTurkmenMenu));
	nActiveLanguage = AL_TURKMEN;	
}

void CMainFrame::OnUpdateTurkmenlang(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(nActiveLanguage == AL_TURKMEN);
}
