// TurkmenNPView.cpp : implementation of the CTurkmenNPView class
//

#include "stdafx.h"
#include "TurkmenNP.h"

#include "TurkmenNPDoc.h"
#include "CntrItem.h"
#include "TurkmenNPView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTurkmenNPView

IMPLEMENT_DYNCREATE(CTurkmenNPView, CRichEditView)

BEGIN_MESSAGE_MAP(CTurkmenNPView, CRichEditView)
	ON_WM_CONTEXTMENU()
	//{{AFX_MSG_MAP(CTurkmenNPView)
	ON_WM_DESTROY()
	ON_COMMAND(ID_BOLD, OnBold)
	ON_UPDATE_COMMAND_UI(ID_BOLD, OnUpdateBold)
	ON_COMMAND(ID_ITALIC, OnItalic)
	ON_UPDATE_COMMAND_UI(ID_ITALIC, OnUpdateItalic)
	ON_COMMAND(ID_STRIKEOUT, OnStrikeout)
	ON_UPDATE_COMMAND_UI(ID_STRIKEOUT, OnUpdateStrikeout)
	ON_COMMAND(ID_UNDERLINE, OnUnderline)
	ON_UPDATE_COMMAND_UI(ID_UNDERLINE, OnUpdateUnderline)
	ON_COMMAND(ID_VIEW_FONT, OnViewFont)
	ON_UPDATE_COMMAND_UI(ID_CENTERED, OnUpdateCentered)
	ON_COMMAND(ID_CENTERED, OnCentered)
	ON_COMMAND(ID_LEFTED, OnLefted)
	ON_UPDATE_COMMAND_UI(ID_LEFTED, OnUpdateLefted)
	ON_COMMAND(ID_RIGHTED, OnRighted)
	ON_UPDATE_COMMAND_UI(ID_RIGHTED, OnUpdateRighted)
	ON_COMMAND(ID_COLOR, OnColor)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRichEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTurkmenNPView construction/destruction

CTurkmenNPView::CTurkmenNPView()
{
	// TODO: add construction code here

}

CTurkmenNPView::~CTurkmenNPView()
{
}

BOOL CTurkmenNPView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CRichEditView::PreCreateWindow(cs);
}

void CTurkmenNPView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();


	// Set the printing margins (720 twips = 1/2 inch).
	SetMargins(CRect(720, 720, 720, 720));
}

/////////////////////////////////////////////////////////////////////////////
// CTurkmenNPView printing

BOOL CTurkmenNPView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}


void CTurkmenNPView::OnDestroy()
{
	// Deactivate the item on destruction; this is important
	// when a splitter view is being used.
   CRichEditView::OnDestroy();
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
}


/////////////////////////////////////////////////////////////////////////////
// CTurkmenNPView diagnostics

#ifdef _DEBUG
void CTurkmenNPView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CTurkmenNPView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CTurkmenNPDoc* CTurkmenNPView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTurkmenNPDoc)));
	return (CTurkmenNPDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTurkmenNPView message handlers



////////////////////////////////////////////
void CTurkmenNPView::OnBold() 
{
	OnCharEffect( CFM_BOLD, CFE_BOLD );			
}

void CTurkmenNPView::OnUpdateBold(CCmdUI* pCmdUI) 
{
	OnUpdateCharEffect(pCmdUI, CFM_BOLD, CFE_BOLD);			
}
////////////////////////////////////////////


void CTurkmenNPView::OnItalic() 
{
	OnCharEffect( CFM_ITALIC, CFE_ITALIC );	
}

void CTurkmenNPView::OnUpdateItalic(CCmdUI* pCmdUI) 
{
	OnUpdateCharEffect(pCmdUI, CFM_ITALIC, CFE_ITALIC);	
}
////////////////////////////////////////////

void CTurkmenNPView::OnStrikeout() 
{
	OnCharEffect( CFM_STRIKEOUT, CFE_STRIKEOUT );		
}

void CTurkmenNPView::OnUpdateStrikeout(CCmdUI* pCmdUI) 
{
	OnUpdateCharEffect(pCmdUI, CFM_STRIKEOUT, CFE_STRIKEOUT);		
}
////////////////////////////////////////////

void CTurkmenNPView::OnUnderline() 
{
	OnCharEffect(CFM_UNDERLINE, CFE_UNDERLINE);	
}

void CTurkmenNPView::OnUpdateUnderline(CCmdUI* pCmdUI) 
{
	OnUpdateCharEffect(pCmdUI, CFM_UNDERLINE, CFE_UNDERLINE);	
}
////////////////////////////////////////////

void CTurkmenNPView::OnViewFont() 
{
	CHARFORMAT CharFormat = GetCharFormatSelection();	
	LOGFONT lf;
	int i = 0;
	
	memset(&lf, 0, sizeof(LOGFONT));

	lf.lfUnderline = (unsigned char)CharFormat.dwEffects & CFE_UNDERLINE;
	lf.lfStrikeOut = (unsigned char)CharFormat.dwEffects & CFE_STRIKEOUT;
	
	if ((unsigned char)CharFormat.dwEffects & CFE_BOLD)
		lf.lfWeight = FW_BOLD;
	else
		lf.lfWeight = FW_NORMAL;

	lf.lfItalic = (unsigned char)CharFormat.dwEffects & CFE_ITALIC;
	lf.lfWidth = NULL;

	while (CharFormat.szFaceName[i])
	{
		lf.lfFaceName[i] = CharFormat.szFaceName[i];
		i++;
	}
	lf.lfFaceName[i] = NULL;
	lf.lfHeight = -MulDiv(CharFormat.yHeight, GetDC()->GetDeviceCaps(LOGPIXELSY), 72)/20;
	lf.lfCharSet = CharFormat.bCharSet;
	lf.lfPitchAndFamily = CharFormat.bPitchAndFamily;
	
	CFontDialog FontDialog(&lf);	
	FontDialog.m_cf.rgbColors = CharFormat.crTextColor;

	if (FontDialog.DoModal() == IDOK)	
	{		
		FontDialog.GetCharFormat(CharFormat);		
		SetCharFormat(CharFormat);	
	}
	
}
////////////////////////////////////////////


void CTurkmenNPView::OnUpdateCentered(CCmdUI* pCmdUI) 
{
	OnUpdateParaAlign(pCmdUI, PFA_CENTER);		
}

void CTurkmenNPView::OnCentered() 
{
	OnParaAlign(PFA_CENTER);
}


void CTurkmenNPView::OnLefted() 
{
	OnParaAlign(PFA_LEFT);	
}

void CTurkmenNPView::OnUpdateLefted(CCmdUI* pCmdUI) 
{
	OnUpdateParaAlign(pCmdUI, PFA_LEFT);	
}

void CTurkmenNPView::OnRighted() 
{
	OnParaAlign(PFA_RIGHT);	
}

void CTurkmenNPView::OnUpdateRighted(CCmdUI* pCmdUI) 
{
	OnUpdateParaAlign(pCmdUI, PFA_RIGHT);		
}

void CTurkmenNPView::OnColor() 
{
	CColorDialog m_cd;
	CHARFORMAT CharFormat = GetCharFormatSelection();	
	COLORREF m_color;
	
	if (m_cd.DoModal() == IDOK)
	{
		m_color = m_cd.GetColor();
		CharFormat.crTextColor = m_color;
		SetCharFormat(CharFormat);	
	}	
}


void CTurkmenNPView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CMenu menu;
	CRichEditView::OnRButtonDown(nFlags, point);	
			//keystroke invocation
	ClientToScreen(&point);
	VERIFY(menu.LoadMenu(CG_IDR_POPUP_VIEW));

	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			this);
}
